import navs from "./menus-data";

let dataList = [];
const idFunc = () => {
  let id = 1;
  return function() {
    return "" + id++;
  };
};
const getId = idFunc();
const extraFields = ["urls", "buttons", "links", "lists", "conditions"];
const checkField = obj => {
  return extraFields.some(field => obj[field] && obj[field].length);
};

const treeToList = (tree, parentId = "-1") => {
  tree.forEach(menu => {
    let id = getId();
    let nmenu = {
      id,
      parentId,
      name: menu.name,
      url: menu.url
    };

    if (checkField(menu)) {
      extraFields.forEach(field => {
        nmenu[field] = [];
        if (menu[field]) {
          nmenu[field] = menu[field].map(item => {
            return {
              name: item.name,
              type: item.type,
              parentId: id,
              url: item.url
            };
          });
        }
      });
    }
    dataList.push(nmenu);

    if (menu.children && menu.children.length) treeToList(menu.children, id);
  });
};
treeToList(navs);

// console.log(JSON.stringify(dataList));

export default dataList;
