import { $postParam, $post } from "@/plugins/axios";

export const questionTeatherUserQuery = ({ courseCode, param }) => {
  return $postParam("/api/admin/sys/user/user_list", { courseCode, param });
};
// user --------------------------------->
// user-manage
export const userListPage = datas => {
  return $postParam("/api/admin/sys/user/list", datas);
};
export const updateUser = datas => {
  return $post("/api/admin/sys/user/save", datas);
};
export const ableUser = ({ id, enable }) => {
  return $post("/api/admin/sys/user/enable", { id, enable });
};
export const resetPwd = id => {
  return $post("/api/admin/sys/user/reset_password", { id });
};
export const updatePwd = datas => {
  return $post("/api/admin/sys/user/update_password", datas);
};
export const userBindRoles = ({ id, roleIds }) => {
  return $post("/api/admin/sys/user/bind_roles", { id, roleIds });
};
export const userRoleListPage = () => {
  return $postParam("/api/admin/sys/role/list_to_user", {});
};
export const syncUserToEcs = () => {
  return $postParam("/api/admin/sys/user/push", {});
};

// role-manage
export const roleListPage = datas => {
  return $postParam("/api/admin/sys/role/list", datas);
};
export const ableRole = ({ id, enable }) => {
  return $post("/api/admin/sys/role/enable", { id, enable });
};
export const updateRole = datas => {
  return $post("/api/admin/sys/role/save", datas);
};
export const deleteRole = id => {
  return $postParam("/api/admin/sys/role/remove", { id });
};
export const userBoundRoles = userId => {
  return $postParam("/api/admin/sys/role/get_user_roles", { userId });
};
// menu-manage
export const menuAuthList = datas => {
  return $postParam("/api/admin/sys/privilege/list_auth", datas);
};
export const privilegeList = datas => {
  return $postParam("/api/admin/sys/privilege/list", datas);
};
export const roleBoundPrivileges = roleId => {
  return $postParam("/api/admin/sys/privilege/get_role_privileges", { roleId });
};
// organization-manage
export const organizationList = datas => {
  return $postParam("/api/admin/sys/org/list", datas);
};
export const organizationFindByTypeList = datas => {
  return $postParam("/api/admin/sys/org/find_by_type", datas);
};
export const updateOrganization = datas => {
  return $post("/api/admin/sys/org/save", datas);
};
export const ableOrganization = ({ id, enable }) => {
  return $post("/api/admin/sys/org/enable", { id, enable });
};
export const deleteOrganization = id => {
  return $post("/api/admin/sys/org/remove", { id });
};

// setting --------------------------------->
// common-rule
export const examRuleDetail = schoolId => {
  return $postParam("/api/admin/basic/exam_rule/list", { schoolId });
};
export const saveExamRule = datas => {
  return $post("/api/admin/basic/exam_rule/save", datas);
};
// card-rule
export const cardRuleListPage = datas => {
  return $postParam("/api/admin/basic/card_rule/list", datas);
};
export const cardRuleQuery = param => {
  return $postParam("/api/admin/basic/card_rule/query", { param });
};
export const cardRuleDetail = id => {
  return $postParam("/api/admin/basic/card_rule/get_one", { id });
};
export const saveCardRule = datas => {
  return $post("/api/admin/basic/card_rule/save", datas);
};
export const ableCardRule = ({ id, enable }) => {
  return $post("/api/admin/basic/card_rule/enable", { id, enable });
};
// common-card-template / common-print-template / param-print-template
export const templateListPage = datas => {
  return $postParam("/api/admin/basic/template/list", datas);
};
export const updateTemplate = datas => {
  return $post("/api/admin/basic/template/save", datas);
};
export const ableTemplate = ({ id, enable }) => {
  return $post("/api/admin/basic/template/enable", { id, enable });
};
export const templateCategoryList = type => {
  return $postParam("/api/admin/basic/template/list", type);
};
export const templateContentView = attachmentId => {
  return $postParam("/api/admin/basic/template/read_content", { attachmentId });
};
// course-manage
export const courseListPage = datas => {
  return $postParam("/api/admin/basic/course/list", datas);
};
export const courseQuery = datas => {
  return $postParam("/api/admin/basic/course/query", datas);
};
export const deleteCourse = idList => {
  return $postParam("/api/admin/basic/course/delete_batch", { idList });
};
export const updateCourse = datas => {
  return $post("/api/admin/basic/course/save", datas);
};
export const ableCourse = ({ idList, enable }) => {
  return $postParam("/api/admin/basic/course/enable", { idList, enable });
};
// flow-manage
export const flowListPage = datas => {
  return $postParam("/api/admin/flow/list", datas);
};
export const flowPublish = id => {
  return $post("/api/admin/flow/publish", { id });
};
export const flowEnd = flowId => {
  return $post("/api/admin/flow/end", { flowId });
};
export const flowDelete = id => {
  return $postParam("/api/admin/flow/enable", { id });
};
export const flowRegister = (datas, headers) => {
  return $post("/api/admin/flow/register", datas, { headers });
};

// approve-record
export const approveRecordListPage = datas => {
  return $postParam("/api/admin/flow/approve/list", datas);
};
export const deleteApproveRecord = datas => {
  return $post("/api/admin/flow/approve/enable", datas);
};

// dict --------------------------------->
// campus-manage
export const campusQuery = () => {
  return $postParam("/api/admin/basic/campus/query", {});
};
export const deleteCampus = id => {
  return $postParam("/api/admin/basic/campus/delete", { id });
};
export const updateCampus = datas => {
  return $post("/api/admin/basic/campus/save", datas);
};

// student-manage
export const studentListQuery = datas => {
  return $postParam("/api/admin/basic/student/query", datas);
};
export const deleteStudent = idList => {
  return $postParam("/api/admin/basic/student/delete_batch", { idList });
};
export const updateStudent = datas => {
  return $post("/api/admin/basic/student/save", datas);
};

// clazz-manage
export const clazzListQuery = datas => {
  return $postParam("/api/admin/basic/clazz/query", datas);
};
export const deleteClazz = idList => {
  return $postParam("/api/admin/basic/clazz/delete_batch", { idList });
};
export const updateClazz = datas => {
  return $post("/api/admin/basic/clazz/save", datas);
};
export const clazzQuery = datas => {
  return $postParam("/api/admin/basic/clazz/datasource", datas);
};
export const classQuery = datas => {
  return $postParam("/api/admin/common/get_dictionary", {
    ...datas,
    dictionaryEnum: "CLAZZ"
  });
};

// semester-manage
export const semesterListQuery = datas => {
  return $postParam("/api/admin/basic/semester/query", datas);
};
export const deleteSemester = id => {
  return $postParam("/api/admin/basic/semester/delete", { id });
};
export const updateSemester = datas => {
  return $post("/api/admin/basic/semester/save", datas);
};
// major-manage
export const majorListQuery = datas => {
  return $postParam("/api/admin/basic/major/query", datas);
};
export const majorQuery = datas => {
  return $postParam("/api/admin/common/get_dictionary", {
    ...datas,
    dictionaryEnum: "MAJOR"
  });
};
export const deleteMajor = id => {
  return $postParam("/api/admin/basic/major/delete", { id });
};
export const updateMajor = datas => {
  return $post("/api/admin/basic/major/save", datas);
};

// other --------------------------------->
// print-plan-push-manage
export const printPlanPushListQuery = datas => {
  return $postParam("/api/admin/exam/print_sync/list_sync", datas);
};
export const printPlanBatchPush = list => {
  return $post("/api/admin/exam/print_sync/sync_data_cloud_batch", {
    list
  });
};
export const printPlanPush = ({ printPlanId, thirdRelateId }) => {
  return $postParam("/api/admin/exam/print_sync/sync_data_cloud", {
    printPlanId,
    thirdRelateId
  });
};
export const printPlanMergePush = datas => {
  return $post("/api/admin/exam/print_sync/sync_data_merge", datas);
};
export const printPlanSyncExamList = () => {
  return $post("/api/admin/exam/print_sync/list_relate_ids", {});
};

// common
export const uploadFile = datas => {
  return $post("/api/admin/common/file/upload", datas);
};
export const getCode = type => {
  return $postParam("/api/admin/common/get_code", { type });
};
