import { waitExamTaskCount, markerTaskCount } from "./api";
import { calcSum } from "@/plugins/utils";

const state = {
  waitTaskCount: 0
};

const mutations = {
  setNotDoneTaskCount(state, waitTaskCount) {
    state.waitTaskCount = waitTaskCount;
  }
};

const actions = {
  async updateWaitTaskCount({ commit }) {
    let countAll = [waitExamTaskCount(), markerTaskCount()];
    const counts = await Promise.all(countAll).catch(() => {});

    const count = calcSum(counts || [0]);
    commit("setNotDoneTaskCount", count || 0);
  }
};

export default {
  namespaced: true,
  state,
  mutations,
  actions
};
